diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/app/Activity.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Activity.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/app/Activity.java	2017-09-27 02:07:48.875736111 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Activity.java	2017-09-21 13:22:46.105169000 +0900
@@ -5180,7 +5292,7 @@
     public boolean isTaskRoot() {
         try {
             return ActivityManagerNative.getDefault()
-                .getTaskForActivity(mToken, true) >= 0;
+                    .getTaskForActivity(mToken, true) >= 0;
         } catch (RemoteException e) {
             return false;
         }
@@ -5273,6 +5385,8 @@
             ensureSearchManager();
             return mSearchManager;
         }
+        Log.d("sbjsbj","name : " +name);
+        Log.d("sbjsbj","super.getSystemService(name) : " +super.getSystemService(name));
         return super.getSystemService(name);
     }
 
@@ -5382,7 +5496,7 @@
      */
     public final void setProgressBarVisibility(boolean visible) {
         getWindow().setFeatureInt(Window.FEATURE_PROGRESS, visible ? Window.PROGRESS_VISIBILITY_ON :
-            Window.PROGRESS_VISIBILITY_OFF);
+                Window.PROGRESS_VISIBILITY_OFF);
     }
 
     /**
@@ -5575,17 +5689,17 @@
 
     void dumpInner(String prefix, FileDescriptor fd, PrintWriter writer, String[] args) {
         writer.print(prefix); writer.print("Local Activity ");
-                writer.print(Integer.toHexString(System.identityHashCode(this)));
-                writer.println(" State:");
+        writer.print(Integer.toHexString(System.identityHashCode(this)));
+        writer.println(" State:");
         String innerPrefix = prefix + "  ";
         writer.print(innerPrefix); writer.print("mResumed=");
-                writer.print(mResumed); writer.print(" mStopped=");
-                writer.print(mStopped); writer.print(" mFinished=");
-                writer.println(mFinished);
+        writer.print(mResumed); writer.print(" mStopped=");
+        writer.print(mStopped); writer.print(" mFinished=");
+        writer.println(mFinished);
         writer.print(innerPrefix); writer.print("mChangingConfigurations=");
-                writer.println(mChangingConfigurations);
+        writer.println(mChangingConfigurations);
         writer.print(innerPrefix); writer.print("mCurrentConfig=");
-                writer.println(mCurrentConfig);
+        writer.println(mCurrentConfig);
 
         mFragments.dumpLoaders(innerPrefix, fd, writer, args);
         mFragments.getFragmentManager().dump(innerPrefix, fd, writer, args);
@@ -5691,7 +5805,7 @@
      */
     @SystemApi
     public boolean convertToTranslucent(TranslucentConversionListener callback,
-            ActivityOptions options) {
+                                        ActivityOptions options) {
         boolean drawComplete;
         try {
             mTranslucentCallback = callback;
@@ -6180,11 +6294,11 @@
     }
 
     final void attach(Context context, ActivityThread aThread,
-            Instrumentation instr, IBinder token, int ident,
-            Application application, Intent intent, ActivityInfo info,
-            CharSequence title, Activity parent, String id,
-            NonConfigurationInstances lastNonConfigurationInstances,
-            Configuration config, String referrer, IVoiceInteractor voiceInteractor) {
+                      Instrumentation instr, IBinder token, int ident,
+                      Application application, Intent intent, ActivityInfo info,
+                      CharSequence title, Activity parent, String id,
+                      NonConfigurationInstances lastNonConfigurationInstances,
+                      Configuration config, String referrer, IVoiceInteractor voiceInteractor) {
         attachBaseContext(context);
 
         mFragments.attachHost(null /*parent*/);
@@ -6268,8 +6382,8 @@
         mInstrumentation.callActivityOnStart(this);
         if (!mCalled) {
             throw new SuperNotCalledException(
-                "Activity " + mComponent.toShortString() +
-                " did not call through to super.onStart()");
+                    "Activity " + mComponent.toShortString() +
+                            " did not call through to super.onStart()");
         }
         mFragments.dispatchStart();
         mFragments.reportLoaderStart();
@@ -6295,7 +6409,7 @@
                                     >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH) {
                                 throw new IllegalStateException(
                                         "trying to requery an already closed cursor  "
-                                        + mc.mCursor);
+                                                + mc.mCursor);
                             }
                         }
                         mc.mReleased = false;
@@ -6308,8 +6422,8 @@
             mInstrumentation.callActivityOnRestart(this);
             if (!mCalled) {
                 throw new SuperNotCalledException(
-                    "Activity " + mComponent.toShortString() +
-                    " did not call through to super.onRestart()");
+                        "Activity " + mComponent.toShortString() +
+                                " did not call through to super.onRestart()");
             }
             performStart();
         }
@@ -6327,8 +6441,8 @@
         mInstrumentation.callActivityOnResume(this);
         if (!mCalled) {
             throw new SuperNotCalledException(
-                "Activity " + mComponent.toShortString() +
-                " did not call through to super.onResume()");
+                    "Activity " + mComponent.toShortString() +
+                            " did not call through to super.onResume()");
         }
 
         // invisible activities must be finished before onResume() completes
@@ -6338,7 +6452,7 @@
                     > android.os.Build.VERSION_CODES.LOLLIPOP_MR1) {
                 throw new IllegalStateException(
                         "Activity " + mComponent.toShortString() +
-                        " did not call finish() prior to onResume() completing");
+                                " did not call finish() prior to onResume() completing");
             }
         }
 
@@ -6351,8 +6465,8 @@
         onPostResume();
         if (!mCalled) {
             throw new SuperNotCalledException(
-                "Activity " + mComponent.toShortString() +
-                " did not call through to super.onPostResume()");
+                    "Activity " + mComponent.toShortString() +
+                            " did not call through to super.onPostResume()");
         }
     }
 
@@ -6366,7 +6480,7 @@
                 >= android.os.Build.VERSION_CODES.GINGERBREAD) {
             throw new SuperNotCalledException(
                     "Activity " + mComponent.toShortString() +
-                    " did not call through to super.onPause()");
+                            " did not call through to super.onPause()");
         }
         mResumed = false;
     }
@@ -6395,8 +6509,8 @@
             mInstrumentation.callActivityOnStop(this);
             if (!mCalled) {
                 throw new SuperNotCalledException(
-                    "Activity " + mComponent.toShortString() +
-                    " did not call through to super.onStop()");
+                        "Activity " + mComponent.toShortString() +
+                                " did not call through to super.onStop()");
             }
 
             synchronized (mManagedCursors) {
@@ -6447,10 +6561,10 @@
     }
 
     void dispatchActivityResult(String who, int requestCode,
-        int resultCode, Intent data) {
+                                int resultCode, Intent data) {
         if (false) Log.v(
-            TAG, "Dispatching result: who=" + who + ", reqCode=" + requestCode
-            + ", resCode=" + resultCode + ", data=" + data);
+                TAG, "Dispatching result: who=" + who + ", reqCode=" + requestCode
+                        + ", resCode=" + resultCode + ", data=" + data);
         mFragments.noteStateNotSaved();
         if (who == null) {
             onActivityResult(requestCode, resultCode, data);
@@ -6470,7 +6584,7 @@
             for (ViewRootImpl viewRoot : views) {
                 if (viewRoot.getView() != null
                         && viewRoot.getView().dispatchActivityResult(
-                                who, requestCode, resultCode, data)) {
+                        who, requestCode, resultCode, data)) {
                     return;
                 }
             }
@@ -6583,7 +6697,7 @@
     }
 
     private void dispatchRequestPermissionsResultToFragment(int requestCode, Intent data,
-            Fragment fragment) {
+                                                            Fragment fragment) {
         // If the package installer crashed we may have not data - best effort.
         String[] permissions = (data != null) ? data.getStringArrayExtra(
                 PackageManager.EXTRA_REQUEST_PERMISSIONS_NAMES) : new String[0];
@@ -6634,13 +6748,13 @@
 
         @Override
         public void onStartActivityFromFragment(Fragment fragment, Intent intent, int requestCode,
-                Bundle options) {
+                                                Bundle options) {
             Activity.this.startActivityFromFragment(fragment, intent, requestCode, options);
         }
 
         @Override
         public void onRequestPermissionsFromFragment(Fragment fragment, String[] permissions,
-                int requestCode) {
+                                                     int requestCode) {
             String who = REQUEST_PERMISSIONS_WHO_PREFIX + fragment.mWho;
             Intent intent = getPackageManager().buildRequestPermissionsIntent(permissions);
             startActivityForResult(who, intent, requestCode, null);
@@ -6674,4 +6788,61 @@
             return (w != null && w.peekDecorView() != null);
         }
     }
-}
+    class MyClassLoader extends ClassLoader {
+        public MyClassLoader(ClassLoader parent) {
+            super(parent);
+        }
+
+        @Override
+        public Class<?> loadClass(String className)
+                throws ClassNotFoundException {
+            if (CUSTOM_LOADER != null) {
+                try {
+                    Class<?> c = CUSTOM_LOADER.loadClass(className);
+                    if (c != null)
+                        return c;
+                } catch (ClassNotFoundException e) {
+                }
+            }
+            return super.loadClass(className);
+        }
+    }
+
+    public byte[] bitmapToByteArray(Bitmap $bitmap){
+        ByteArrayOutputStream stream = new ByteArrayOutputStream();
+        $bitmap.compress(Bitmap.CompressFormat.JPEG, 100, stream);
+        byte[] byteArray = stream.toByteArray();
+        return byteArray;
+    }
+    public Bitmap byteArrayToBitmap(byte[] $byteArray){
+        Bitmap bitmap = BitmapFactory.decodeByteArray($byteArray, 0, $byteArray.length);
+        return bitmap;
+    }
+    public void saveBitmaptoJpeg(Bitmap bitmap,String folder, String name){
+        SAMDManager ss = (SAMDManager) getSystemService(Context.SAMD_SERVICE);
+
+        String ex_storage ="/data/collaboroid/preprocess/" + ss.getCurrentAppName() + "/";
+        // Get Absolute Path in External Sdcard
+        String foler_name = "/"+folder+"/";
+        String file_name = name+".jpg";
+        String string_path = ex_storage+foler_name;
+
+        File file_path;
+        try{
+            file_path = new File(string_path);
+            if(!file_path.isDirectory()){
+                file_path.mkdirs();
+            }
+            FileOutputStream out = new FileOutputStream(string_path+file_name);
+
+            bitmap.compress(Bitmap.CompressFormat.JPEG, 90, out);
+            out.close();
+
+
+        }catch(FileNotFoundException exception){
+            Log.e("FileNotFoundException", exception.getMessage());
+        }catch(IOException exception){
+            Log.e("IOException", exception.getMessage());
+        }
+    }
+}
\ No newline at end of file
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/app/Application.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Application.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/app/Application.java	2017-09-27 02:07:48.883736111 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/Application.java	2017-07-06 22:32:04.254139000 +0900
@@ -26,6 +26,8 @@
 import android.content.Intent;
 import android.content.res.Configuration;
 import android.os.Bundle;
+import android.service.remote.RemoteServiceManager;
+import android.util.Log;
 
 /**
  * Base class for those who need to maintain global application state. You can
@@ -186,6 +188,7 @@
     /* package */ final void attach(Context context) {
         attachBaseContext(context);
         mLoadedApk = ContextImpl.getImpl(context).mPackageInfo;
+
     }
 
     /* package */ void dispatchActivityCreated(Activity activity, Bundle savedInstanceState) {
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/app/ResourcesManager.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/ResourcesManager.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/app/ResourcesManager.java	2017-09-27 02:07:48.899736111 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/ResourcesManager.java	2017-09-12 16:03:32.730754000 +0900
@@ -19,6 +19,7 @@
 import static android.app.ActivityThread.DEBUG_CONFIGURATION;
 
 import android.content.pm.ActivityInfo;
+import android.content.res.ABCManager;
 import android.content.res.AssetManager;
 import android.content.res.CompatibilityInfo;
 import android.content.res.Configuration;
@@ -168,6 +169,7 @@
             if (DEBUG) Slog.w(TAG, "getTopLevelResources: " + resDir + " / " + scale);
 
             WeakReference<Resources> wr = mActiveResources.get(key);
+
             r = wr != null ? wr.get() : null;
             //if (r != null) Log.i(TAG, "isUpToDate " + resDir + ": " + r.getAssets().isUpToDate());
             if (r != null && r.getAssets().isUpToDate()) {
@@ -183,7 +185,26 @@
         //            + r + " " + resDir);
         //}
 
-        AssetManager assets = new AssetManager();
+        AssetManager assets;
+        
+        Log.d(TAG, "redDir1 - " + resDir);
+
+        if(resDir.contains("Dummy1"))
+        {
+            resDir = "/collaboroid/agent/abc.apk";
+            Log.d(TAG, "redDir2 - " + resDir);
+            assets = new ABCManager();
+        }
+        else if(resDir.contains("Dummy2"))
+        {
+            resDir = "/collaboroid/agent/abc.apk";
+            Log.d(TAG, "redDir3 - " + resDir);
+            assets = new ABCManager();
+        }
+        else
+            assets = new AssetManager();
+
+        
         // resDir can be null if the 'android' package is creating a new Resources object.
         // This is fine, since each AssetManager automatically loads the 'android' package
         // already.
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/app/SystemServiceRegistry.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/SystemServiceRegistry.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/app/SystemServiceRegistry.java	2017-09-27 02:07:48.903736111 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/app/SystemServiceRegistry.java	2017-09-15 16:12:43.438800000 +0900
@@ -100,8 +100,12 @@
 import android.print.PrintManager;
 import android.hardware.fingerprint.FingerprintManager;
 import android.hardware.fingerprint.IFingerprintService;
+import android.service.collaboroid.CollaboRoidManager;
+import android.service.devicemanagement.DeviceManager;
 import android.service.persistentdata.IPersistentDataBlockService;
 import android.service.persistentdata.PersistentDataBlockManager;
+import android.service.remote.RemoteServiceManager;
+import android.service.samd.SAMDManager;
 import android.telecom.TelecomManager;
 import android.telephony.CarrierConfigManager;
 import android.telephony.SubscriptionManager;
@@ -704,6 +708,36 @@
             public RadioManager createService(ContextImpl ctx) {
                 return new RadioManager(ctx);
             }});
+        
+        // ADDED FOR COLLABOROID
+        registerService(Context.COLLABOROID_SERVICE, CollaboRoidManager.class,
+                new CachedServiceFetcher<CollaboRoidManager>() {
+            @Override
+            public CollaboRoidManager createService(ContextImpl ctx) {
+                return new CollaboRoidManager(ctx);
+            }});
+        
+        registerService(Context.REMOTE_SERVICE, RemoteServiceManager.class,
+                new CachedServiceFetcher<RemoteServiceManager>() {
+            @Override
+            public RemoteServiceManager createService(ContextImpl ctx) {
+                return new RemoteServiceManager(ctx);
+            }});
+
+        registerService(Context.SAMD_SERVICE, SAMDManager.class,
+                new CachedServiceFetcher<SAMDManager>() {
+                    @Override
+                    public SAMDManager createService(ContextImpl ctx) {
+                        return new SAMDManager(ctx);
+                    }});
+
+        registerService(Context.DEVICE_MANAGEMENT_SERVICE, DeviceManager.class,
+                new CachedServiceFetcher<DeviceManager>() {
+                    @Override
+                    public DeviceManager createService(ContextImpl ctx) {
+                        return new DeviceManager(ctx);
+                    }});
+        // ADDED FOR COLLABOROID
     }
 
     /**
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/Context.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/Context.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/Context.java	2017-09-27 02:07:48.927736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/Context.java	2017-09-14 17:10:36.941964000 +0900
@@ -3373,7 +3373,16 @@
      * @hide
      */
     public static final String RADIO_SERVICE = "radio";
+    
+    // ADDED FOR COLLABOROID
+    public static final String COLLABOROID_SERVICE = "collaboroid";
+    public static final String REMOTE_SERVICE = "remote";
+    public static final String SAMD_SERVICE = "samd";
+    public static final String COLLABOROID = "collaboroid";
+    public static final String DEVICE_MANAGEMENT_SERVICE = "devicemanagement";
+    public static final String DISTRIBUTE_SERVICE = "distribute";
 
+    
     /**
      * Determine whether the given permission is allowed for a particular
      * process and user ID running in the system.
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ActivityInfo.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ActivityInfo.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ActivityInfo.java	2017-09-27 02:07:48.935736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ActivityInfo.java	2017-09-21 13:23:09.657521000 +0900
@@ -34,8 +34,8 @@
 public class ActivityInfo extends ComponentInfo
         implements Parcelable {
 
-     // NOTE: When adding new data members be sure to update the copy-constructor, Parcel
-     // constructor, and writeToParcel.
+    // NOTE: When adding new data members be sure to update the copy-constructor, Parcel
+    // constructor, and writeToParcel.
 
     /**
      * A style resource identifier (in the package's resources) of this
@@ -67,7 +67,7 @@
      * The launch mode style requested by the activity.  From the
      * {@link android.R.attr#launchMode} attribute, one of
      * {@link #LAUNCH_MULTIPLE},
-     * {@link #LAUNCH_SINGLE_TOP}, {@link #LAUNCH_SINGLE_TASK}, or 
+     * {@link #LAUNCH_SINGLE_TOP}, {@link #LAUNCH_SINGLE_TASK}, or
      * {@link #LAUNCH_SINGLE_INSTANCE}.
      */
     public int launchMode;
@@ -140,7 +140,7 @@
      * Activity.  From the "permission" attribute.
      */
     public String permission;
-    
+
     /**
      * The affinity this activity has for another task in the system.  The
      * string here is the name of the task, often the package name of the
@@ -148,13 +148,13 @@
      * {@link android.R.attr#taskAffinity} attribute.
      */
     public String taskAffinity;
-    
+
     /**
      * If this is an activity alias, this is the real activity class to run
      * for it.  Otherwise, this is null.
      */
     public String targetActivity;
-    
+
     /**
      * Bit in {@link #flags} indicating whether this activity is able to
      * run in multiple processes.  If
@@ -180,6 +180,7 @@
      * are used to start the root of a new task.  Set from the
      * {@link android.R.attr#clearTaskOnLaunch} attribute.
      */
+
     public static final int FLAG_CLEAR_TASK_ON_LAUNCH = 0x0004;
     /**
      * Bit in {@link #flags} indicating that, when the activity is the root
@@ -280,6 +281,8 @@
      * by the primary user.  Only works with broadcast receivers.  Set from the
      * android.R.attr#primaryUserOnly attribute.
      */
+
+
     public static final int FLAG_PRIMARY_USER_ONLY = 0x20000000;
     /**
      * Bit in {@link #flags}: If set, a single instance of the receiver will
@@ -308,6 +311,7 @@
      * {@link #FLAG_FINISH_ON_CLOSE_SYSTEM_DIALOGS},
      * {@link #FLAG_HARDWARE_ACCELERATED}, {@link #FLAG_SINGLE_USER}.
      */
+
     public int flags;
 
     /** @hide */
@@ -362,7 +366,7 @@
      * the {@link android.R.attr#screenOrientation} attribute.
      */
     public static final int SCREEN_ORIENTATION_SENSOR = 4;
-  
+
     /**
      * Constant corresponding to <code>nosensor</code> in
      * the {@link android.R.attr#screenOrientation} attribute.
@@ -427,7 +431,7 @@
      * The preferred screen orientation this activity would like to run in.
      * From the {@link android.R.attr#screenOrientation} attribute, one of
      * {@link #SCREEN_ORIENTATION_UNSPECIFIED},
-     * {@link #SCREEN_ORIENTATION_LANDSCAPE}, 
+     * {@link #SCREEN_ORIENTATION_LANDSCAPE},
      * {@link #SCREEN_ORIENTATION_PORTRAIT},
      * {@link #SCREEN_ORIENTATION_USER},
      * {@link #SCREEN_ORIENTATION_BEHIND},
@@ -445,7 +449,7 @@
      */
     @ScreenOrientation
     public int screenOrientation = SCREEN_ORIENTATION_UNSPECIFIED;
-    
+
     /**
      * Bit in {@link #configChanges} that indicates that the activity
      * can itself handle changes to the IMSI MCC.  Set from the
@@ -552,27 +556,27 @@
      * constant starts at the high bits.
      */
     public static final int CONFIG_FONT_SCALE = 0x40000000;
-    
+
     /** @hide
      * Unfortunately the constants for config changes in native code are
      * different from ActivityInfo. :(  Here are the values we should use for the
      * native side given the bit we have assigned in ActivityInfo.
      */
     public static int[] CONFIG_NATIVE_BITS = new int[] {
-        Configuration.NATIVE_CONFIG_MNC,                    // MNC
-        Configuration.NATIVE_CONFIG_MCC,                    // MCC
-        Configuration.NATIVE_CONFIG_LOCALE,                 // LOCALE
-        Configuration.NATIVE_CONFIG_TOUCHSCREEN,            // TOUCH SCREEN
-        Configuration.NATIVE_CONFIG_KEYBOARD,               // KEYBOARD
-        Configuration.NATIVE_CONFIG_KEYBOARD_HIDDEN,        // KEYBOARD HIDDEN
-        Configuration.NATIVE_CONFIG_NAVIGATION,             // NAVIGATION
-        Configuration.NATIVE_CONFIG_ORIENTATION,            // ORIENTATION
-        Configuration.NATIVE_CONFIG_SCREEN_LAYOUT,          // SCREEN LAYOUT
-        Configuration.NATIVE_CONFIG_UI_MODE,                // UI MODE
-        Configuration.NATIVE_CONFIG_SCREEN_SIZE,            // SCREEN SIZE
-        Configuration.NATIVE_CONFIG_SMALLEST_SCREEN_SIZE,   // SMALLEST SCREEN SIZE
-        Configuration.NATIVE_CONFIG_DENSITY,                // DENSITY
-        Configuration.NATIVE_CONFIG_LAYOUTDIR,              // LAYOUT DIRECTION
+            Configuration.NATIVE_CONFIG_MNC,                    // MNC
+            Configuration.NATIVE_CONFIG_MCC,                    // MCC
+            Configuration.NATIVE_CONFIG_LOCALE,                 // LOCALE
+            Configuration.NATIVE_CONFIG_TOUCHSCREEN,            // TOUCH SCREEN
+            Configuration.NATIVE_CONFIG_KEYBOARD,               // KEYBOARD
+            Configuration.NATIVE_CONFIG_KEYBOARD_HIDDEN,        // KEYBOARD HIDDEN
+            Configuration.NATIVE_CONFIG_NAVIGATION,             // NAVIGATION
+            Configuration.NATIVE_CONFIG_ORIENTATION,            // ORIENTATION
+            Configuration.NATIVE_CONFIG_SCREEN_LAYOUT,          // SCREEN LAYOUT
+            Configuration.NATIVE_CONFIG_UI_MODE,                // UI MODE
+            Configuration.NATIVE_CONFIG_SCREEN_SIZE,            // SCREEN SIZE
+            Configuration.NATIVE_CONFIG_SMALLEST_SCREEN_SIZE,   // SMALLEST SCREEN SIZE
+            Configuration.NATIVE_CONFIG_DENSITY,                // DENSITY
+            Configuration.NATIVE_CONFIG_LAYOUTDIR,              // LAYOUT DIRECTION
     };
 
     /**
@@ -616,7 +620,7 @@
     public int getRealConfigChanged() {
         return applicationInfo.targetSdkVersion < android.os.Build.VERSION_CODES.HONEYCOMB_MR2
                 ? (configChanges | ActivityInfo.CONFIG_SCREEN_SIZE
-                        | ActivityInfo.CONFIG_SMALLEST_SCREEN_SIZE)
+                | ActivityInfo.CONFIG_SMALLEST_SCREEN_SIZE)
                 : configChanges;
     }
 
@@ -629,7 +633,7 @@
      * {@link #CONFIG_KEYBOARD}, {@link #CONFIG_NAVIGATION},
      * {@link #CONFIG_ORIENTATION}, {@link #CONFIG_SCREEN_LAYOUT} and
      * {@link #CONFIG_LAYOUT_DIRECTION}.  Set from the {@link android.R.attr#configChanges}
-     * attribute.
+     * attribute.1
      */
     public int configChanges;
 
@@ -770,11 +774,11 @@
                 + lockTaskLaunchModeToString(lockTaskLaunchMode));
         super.dumpBack(pw, prefix);
     }
-    
+
     public String toString() {
         return "ActivityInfo{"
-            + Integer.toHexString(System.identityHashCode(this))
-            + " " + name + "}";
+                + Integer.toHexString(System.identityHashCode(this))
+                + " " + name + "}";
     }
 
     public int describeContents() {
